#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	256
#define	MAXHEIGHT	200

void	convpic(int,int,int c_pixel[8][8],int pixel[16][8]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[16][8];
	int		c_pixel[8][8];
//	int		pixel_all[MAXWIDTH][MAXHEIGHT];

	int		width_all,height_all;
	int		width,height;
	int		xa,ya,za;
	int		x,y,col;
	int		c,m,i,sft,a0,a1;

	if (argc != 3) {
		fprintf(stderr, "Usage: convcharabg infile outfile \n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	width  = 16;
	height = 8;

	for (za = 0;za < 4;za ++) {
		for (ya = 0;ya < 25;ya ++) {
			for (xa = 0;xa < 2;xa ++) {

				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel[x][y] = 0x08;
					}
				}

/* GRB */
				for (col = 0x01;col < 0x08;col *= 2) {
					for (y = 0;y < height;y ++) {
						for (x = 0;x < width;x += 8) {
							c = fgetc(infp);
							sft = 0x80;
							for (i = 0;i < 8;i ++) {
								if ( (c & sft) != 0) {
									pixel[x+i][y] |= col;
								}
								sft /= 2;
							}
						}
					}
				}

				convpic(16,8,c_pixel,pixel);

/* A{tO(0000)A{tO(0001j */
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width/2;x ++) {
						if (c_pixel[x][y] == 0x0b) {
							c_pixel[x][y] = 0x00;
						} else if (c_pixel[x][y] == 0x08) {
							c_pixel[x][y] = 0x0b;
						} else if (c_pixel[x][y] == 0x09) {
							c_pixel[x][y] = 0x01;
						}
					}
				}

				for (y = 0;y < height;y +=2) {
					for (x = 0;x < width/2;x +=4) {
						a0 = (c_pixel[x+0][y+0] & 0x0f);
						a1 = (c_pixel[x+1][y+0] & 0x0f) << 4;
						fputc(a0|a1, outfp);
						a0 = (c_pixel[x+2][y+0] & 0x0f);
						a1 = (c_pixel[x+3][y+0] & 0x0f) << 4;
						fputc(a0|a1, outfp);
						a0 = (c_pixel[x+0][y+1] & 0x0f);
						a1 = (c_pixel[x+1][y+1] & 0x0f) << 4;
						fputc(a0|a1, outfp);
						a0 = (c_pixel[x+2][y+1] & 0x0f);
						a1 = (c_pixel[x+3][y+1] & 0x0f) << 4;
						fputc(a0|a1, outfp);
					}
				}

/*
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel_all[xa*width + za*width*2 +x          ][ya*height +y] = c_pixel[x/2][y];
						pixel_all[xa*width + za*width*2 +x + width*8][ya*height +y] = c_pixel[x/2][y];
					}
				}
*/

			}
		}
	}


	for (za = 0;za < 4;za ++) {
		for (ya = 0;ya < 25;ya ++) {
			for (xa = 0;xa < 2;xa ++) {

				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel[x][y] = 0x00;
					}
				}

/* }XN */
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x += 8) {
						c = fgetc(infp);
						sft = 0x80;
						for (i = 0;i < 8;i ++) {
							if ( (c & sft) != 0) {
								pixel[x+i][y] |= 0x0f;
							}
							sft /= 2;
						}
					}
				}

				convpic(16,8,c_pixel,pixel);

				for (y = 0;y < height;y ++) {
					a0 =
						( (c_pixel[0][y] == 0x00) ? 0x00 : 0x80) +
						( (c_pixel[1][y] == 0x00) ? 0x00 : 0x40) +
						( (c_pixel[2][y] == 0x00) ? 0x00 : 0x20) +
						( (c_pixel[3][y] == 0x00) ? 0x00 : 0x10) +
						( (c_pixel[4][y] == 0x00) ? 0x00 : 0x08) +
						( (c_pixel[5][y] == 0x00) ? 0x00 : 0x04) +
						( (c_pixel[6][y] == 0x00) ? 0x00 : 0x02) +
						( (c_pixel[7][y] == 0x00) ? 0x00 : 0x01) ;
					fputc(a0, outfp);
				}


/*
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel_all[xa*width + za*width*2 +x + width*8][ya*height +y] &= c_pixel[x/2][y];
					}
				}
*/

			}
		}
	}

	for (i = 0;i < 256-200;i ++) {
		c = fgetc(infp);
		fputc(c, outfp);
	}


	fclose(outfp);

	fclose(infp);

	return(0);
}

void	convpic(int picsize_x,int picsize_y,int c_pixel[8][8],int pixel[16][8])
{

	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	return;
}

