
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	SIZE_L	14
#define	SIZE_S	6
#define	MAXPAT	254

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		a1,a2,a3,a4;
	int		n,x,y;
	int		xsz,ysz;
	int		i,j;
	int		pflag;
	int		pat[MAXPAT][2];
	int		patnum;
	int		sftl,sfth;


	if (argc != 3) {
		fprintf(stderr, "Usage: convlight infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	patnum = 0;


/* p^[ǂݍ */

	for (n = 0;n < 3;n ++) {

		for (y = 0;y < SIZE_L;y ++) {
			for (x = 0;x < SIZE_L;x ++) {

				if (n == 2 && (
					y <           (SIZE_L-SIZE_S)/2 ||
					y >= SIZE_L - (SIZE_L-SIZE_S)/2 ||
					x <           (SIZE_L-SIZE_S)/2 ||
					x >= SIZE_L - (SIZE_L-SIZE_S)/2
				)) {
					a1 = 0xff;
					a2 = 0xff;
				} else {
					if ( (a1 = fgetc(infp)) == EOF) {
						fprintf(stderr,"Illigal file length.\n");
						exit(1);
					}
					if ( (a2 = fgetc(infp)) == EOF) {
						fprintf(stderr,"Illigal file length.\n");
						exit(1);
					}
				}

				if (a1 == 0x00 && a2 == 0x00) {
					fputc(0x00 ,outfp);					/* S}XN */
				} else if (a1 == 0xff && a2 == 0xff) {
					fputc(0xff ,outfp);					/* S\ */
				} else {
					pflag = 0;
					for (i = 0;i < patnum;i ++) {
						if (a1 == pat[i][0] && a2 == pat[i][1]) {
							pflag = 1;
							break;
						}
					}
					if (pflag == 0) {
						i = patnum;
						pat[i][0] = a1;
						pat[i][1] = a2;
						patnum ++;
					}
					fputc(i+1 ,outfp);					/* p^[0x01`0xfe */
				}
			}
		}
	}

/* 88̃eLXgVRAMp^[P6SRVRAMp^[ϊ */

/* 88eLXgVRAM  */
/* B7-0F1oCg */
/* b7-0F2oCg */
/*                 */
/*   B0 B4 b0 b4   */
/*   B1 B5 b1 b5   */
/*   B2 B6 b2 b6   */
/*   B3 B7 b3 b7   */

/* P6SRVRAM                     */
/*                                  */
/*  00L 00H 01L 01H 03L 03H 04L 04H */
/*  02L 02H 02L 02H 05L 05H 06L 06H */
/*  10L 10H 11L 11H 13L 13H 14L 14H */
/*  12L 12H 12L 12H 15L 15H 16L 16H */
/*  20L 20H 21L 21H 23L 23H 24L 24H */
/*  22L 22H 22L 22H 25L 25H 26L 26H */
/*  30L 30H 31L 31H 33L 33H 34L 34H */
/*  32L 32H 32L 32H 35L 35H 36L 36H */

	for (i = 0;i < patnum; i ++) {
		sftl = 0x01;
		sfth = 0x10;
		for (y = 0;y < 4;y ++) {
			a1 = ((pat[i][0] & sftl) == 0x00) ? 0xff : 0x88;
			a2 = ((pat[i][0] & sfth) == 0x00) ? 0xff : 0x88;
			a3 = ((pat[i][1] & sftl) == 0x00) ? 0xff : 0x88;
			a4 = ((pat[i][1] & sfth) == 0x00) ? 0xff : 0x88;
			fputc(a1, outfp);
			fputc(a2, outfp);
			fputc(a1, outfp);
			fputc(a2, outfp);
			fputc(a3, outfp);
			fputc(a4, outfp);
			fputc(a3, outfp);
			fputc(a4, outfp);
			sftl *= 2;
			sfth *= 2;
		}
	}


	fclose(infp);
	fclose(outfp);

	return(0);
}
